﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

namespace howto_bottommost
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("user32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool SetWindowPos(
            IntPtr hWnd, IntPtr hWndInsertAfter,
            int x, int y, int cx, int cy, uint uFlags);

        // Constants for detecting messages.
        private const int WM_WINDOWPOSCHANGING = 0x0046;

        // Constants for positioning the window.
        private IntPtr HWND_BOTTOM = (IntPtr)1;
        private const UInt32 SWP_NOMOVE = 0x0002;
        private const UInt32 SWP_NOSIZE = 0x0001;

        protected override void WndProc(ref Message m)
        {
            // See if we should be bottommost.
            if (radBottommost.Checked)
            {
                if (m.Msg == WM_WINDOWPOSCHANGING)
                {
                    // We're being activated. Move to the bottom.
                    MoveToBottom();
                    m.Result = (IntPtr)0;
                }
            }

            // Handle the message normally.
            base.WndProc(ref m);
        }

        // Move to the bottom.
        private void MoveToBottom()
        {
            UInt32 flags = SWP_NOSIZE | SWP_NOMOVE;
            if (!SetWindowPos(this.Handle, HWND_BOTTOM, 0, 0, 0, 0, flags))
                Console.WriteLine("Error in SetWindowPos");
        }

        private void radOption_Click(object sender, EventArgs e)
        {
            this.TopMost = radTopmost.Checked;
            if (radBottommost.Checked) MoveToBottom();
        }
    }
}
